# Print Server Configuration: CUPS

Start the print server configuration (now that you have chosen &CUPS;, this is equivalent to the configuration of the &CUPS; daemon) by clicking on the appropriate button. You can find it by moving the mouse slowly over the buttons and reading the tooltips. It should be the 11th from the left , or third from the right; its icon is a wrench.

The &CUPS; Server Configuration window pops up. It gives you a structured view of all the settings that apply to the &CUPS; daemon. The configuration file for that daemon is normally located in `/etc/cups/cupsd.conf`. This is a plain ASCII file with a syntax similar to the configuration file of the Apache web server. It is a good idea to create a backup copy, just in case something goes wrong with the configuration through &kdeprint;/&CUPS; Server Configuration dialogues:

    cp /etc/cups/cupsd.conf /etc/cups/cupsd.conf.bak

As this graphical user interface to edit the configuration file is such a new feature, you should have the second chance of resorting to the original file. So back it up, please.

## Quick Help

One very nice feature is the Quick Help available. If you click on the little question mark (What's this?) on your window title bar, you'll see the cursor changing its form. Now click on a `cupsd` configuration setting field to find out what it means and what your options are. In most cases you should understand the meaning immediately, otherwise turn to the excellent &CUPS; documentation. (If your &CUPS; Daemon is running, you have it online on your own host at http://localhost:631/documentation.html.

If &CUPS; is not running, but installed on your system you could find it in your own host's file system. The exact location depends on your &OS;, but on &Linux; the default is `/usr/share/doc/cups/` or `/usr/share/doc/cups/documentation.html`.

## Longer Help

For the best, most detailed and most recent information you should always refer to the original &CUPS; documentation. &CUPS; is, much like &kde; in a rapid development process. There are constantly new features being added. New features might for times be only configurable by directly editing the configuration files. The &kdeprint; &GUI; might not have caught up with &CUPS; development.

Just in case you want to look at the original configuration files of your &CUPS; system -- they are here:

These paths are based on the default installation. Your &OS; may have installed them to a different prefix, for example, `/usr/local/`, but the hierarchy should still match that shown below.

`/etc/cups/`

  The directory with the configuration files

`/etc/cups/cupsd.conf`

  The configuration file for the &CUPS; daemon

`/etc/cups/printers.conf`

  The configuration file that contains the information about your locally installed printers.

`/etc/cups/ppd/`

  The directory with &PPD; files of your installed printers.

The following links only work if your &CUPS; daemon is up and running. To access all the original &CUPS; documentation, go to:

http://localhost:631/documentation.html

  A page with all the links to the other documents.

http://localhost:631/sam.html

  Direct access to the &CUPS; Software Administrator Manual in HTML format.

http://localhost:631/sam.pdf

  Direct access to the &CUPS; Software Administrator Manual in PDF format.

http://www.cups.org/documentaiton.html

  The latest on line documentation from the &CUPS; web site.

The following links give you access to the same files (probably icons and grapphis will be missing) even if your CUPS daemon is not up and running. You need, however, CUPS installed on your system. (Some distributions might place the files somewhere else -- you're on your own then to find out where...) To access all the original CUPS documentation, go to:

This documentation is available even when the &CUPS; daemon is not installed, although you may find images and icons are missing when you view the HTML files.

As noted above, the hierarchy below should be intact, but your &OS; may have installed &CUPS; to a different location.

`/usr/share/doc/cups/documentation.html`

  A page with all the links to the other documents.

`/usr/share/doc/cups/sam.html`

  Direct access to the &CUPS; Software Administrator Manual in HTML format.

`/usr/share/doc/cups/sam.pdf`

  Direct access to the &CUPS; Software Administrator Manual in PDF format.

There are a few WebSites and Newsgroups discussing &CUPS; (and &Linux; Printing in General) and giving help to newbies at:

http://www.cups.org/newsgroups.php

  The &CUPS; website.

http://www.linuxprinting.org/newsportal/

  LinuxPrinting.org, the home of the Linuxprinting HOWTO and the &Linux; Printer Database

And finally, there will be a WebSite for &kdeprint; and related documentation, at http://kdeprint.sourceforge.net/

In the next section I will step you through most of the configuration options of &kdeprint; with &CUPS;.

## Explaining different elements of the &GUI;

### Upper Window: View on Printers, both Real and Virtual

This section is not yet complete

- Tree view, icon view and list view

- The icons of the task bar

- Different fonts for different printers

- Different printer icons mean different things

### Lower Window: Tabbed View of Details

This section is not yet complete.

- The icons of the task bar

- The Tabs

- Changing printer settings

## Welcome to the &CUPS; Server Configuration

This is the Welcome Screen for your server configuration dialogues. Clicking onto one of the items of the tree view on left side of the screen opens the appropriate part of the configuration settings.

Every setting has a default value. The defaults let &CUPS; normally work as a fully functional client. The clients listen on TCP/IP Port 631 for infos broadcast by &CUPS; servers on the LAN. This information let the clients print immediately after receiving them, without installing any driver or configuring any printer on the clients.

To configure a &CUPS; server (which is broadcasting its service to the LAN) you need to change settings from the defaults.

The dialogue to configure the &CUPS; server: welcome screen.

CUPS server configuration dialogue: welcome screen
The dialogue to configure the &CUPS; server: welcome screen

The dialogue to configure the &CUPS; server: welcome screen

To select the default setting of any item just enable the checkbox on the right side of the screen. To set an item to a different value, disable the checkbox and then go on to do the setting you want on the left side of the screen.

The complete server configuration includes:

- Server General Configuration

- Server Logging Configuration

- Server Directories and Path Definitions

- Server HTTP Configuration

- Server Encryption and Certificate Support Configuration

- Server Miscellaneous Configuration

- Network General Configuration

- Network Clients Configuration

- Browsing General Configuration

- Browsing Connection Configuration

- Browsing Masks Configuration

- Browsing Timeouts Configuration

- Browsing Relay Configuration

- Security Configuration

Each of these configuration items will be described in the following sections of the manual.

## Server General Configuration

The server general configuration is done on this screen. It includes:

- Server name

- Administrator's email

- Server user

- Server group

- Remote user name

The tab window to configure the &CUPS; server general settings lets you the change the default values. Click on the little question mark and then on one of the fields to get a Quick Help about the meaning of the setting.

If you are unsure, leave alone and turn to the original &CUPS; documentation first. If your &CUPS; daemon is already running, it is readable from the &konqueror; by pointing it to &URL; http://localhost:631/documentation.html.

There, first make friends with the Software Adminstrator Manual. Otherwise, for example, if the &CUPS; daemon is not running, try looking in your local file system, by default at `/usr/share/doc/cups/` or `/usr/share/doc/cups/documentation.html`.

&CUPS; server general configuration dialogue: ServerName, AdminMail, ServerUser, ServerGroup, RemoteUserName
The dialogue to configure the &CUPS; server general settings: ServerName, AdminMail, ServerUser, ServerGroup, RemoteUserName

Server Name

  The hostname of your server, as advertised to the world. By default, &CUPS; will use the hostname of the system. To set the default server usd by clients, see the `client.conf` file.

  For example, enter `myhost.domain.com`

  This is the hostname that is reported to clients. Should you ever encounter strange problems in accessing the server, put here its IP address for troubleshooting. This way you eliminate any potential name resolution problems; and you can more easily nail the real problem down.

Administrator's email

  This is the email address to send all complaints or problems to. By default &CUPS; will use root@hostname.

  For example, enter `root@myhost.com`.

  Contrary to what the quickhelp suggests, it is also legal to send an email full of praise and enthusiasm about &CUPS; and &kdeprint; to the server adminstrator.

Server User

  The user the server runs under. Normally this must be lp, however you can configure things for another user if needed.

  The server must be initially run as root to support the default IPP port of 631. It changes users whenever an external program is run.

  Enter for example `lp`.

  This is the &UNIX; user account for filters and CGI programs to run under. CGI programs are resposible for showing you the nice web administration interface accessible via http://localhost:631/).

  There is no need to set the User directive to root, so never do this, as it only involves dangers. Should anyone discover security vulnerabilities in one of the used file filters, printer drivers or CGI programs, he could remotely execute arbitrary commands on your system with root user privileges. Always use an unprivileged account for the server directive User.

Server group

  The group the server runs under. Normally this must be sys, however you can configure things for another group as needed.

  Enter for example `sys`.

Remote user name

  The name of the user assigned to unauthenticated accesses from remote systems. By default `remroot`.

  This name will appear in log files and in queries about the job owner &etc;, for all resources and locations of the &CUPS; server that are configured to allow access without authentication. Authenticated entries will carry the authenticated names.

## Server Logging Configuration

The server logging configuration is done on this screen. It includes:

- Access log file setting

- Error log file setting

- Page log file setting

- Log level setting

- Max log file size setting

This is an important screen for you. Should you ever encounter problems: here is the place to set the Log level to debug, restart the &CUPS; daemon and then look at the Error log file defined here for entries that might give you an insight to the trouble.

&CUPS; server configuration dialogue: Server logging
The dialogue to configure the &CUPS; server: Server logging

Access log file

  This is where accesses to the server are logged. If this does not start with a leading `/`, then it is assumed to be relative to the server root.

  You can also use the special name `syslog` to send the output to the syslog file or daemon.

  Enter a path, for example ``/var/log/cups/acces_log``.

  The format of this file is stored in the so-called Common Log Format. This way you can use programs such as Webalizer or any other Web access reporting tool to generate reports on the &CUPS; server activities.

  To include the server name in the file name use a %s in the name. Example: ``/var/log/cups/access_log-%s``.

      kurt@transmeta:~
      >tail /var/log/cups/access_log

      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "POST /printers/ HTTP/1.1" 200 109
      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "POST /admin/ HTTP/1.1" 401 0
      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "POST / HTTP/1.1" 200 210
      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "GET /ppd/DANKA_P450.ppd HTTP/1.1" 200 51021
      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "POST /jobs/ HTTP/1.1" 200 246
      10.160.16.45 - - [04/Aug/2001:20:11:39 +0100] "GET /printers/DANKA_P450 HTTP/1.0" 200 0
      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "POST / HTTP/1.1" 200 80
      127.0.0.1    - - [04/Aug/2001:20:11:39 +0100] "POST / HTTP/1.1" 200 139
      10.160.16.45 - - [04/Aug/2001:20:11:40 +0100] "GET /cups.css HTTP/1.0" 200 198
      127.0.0.1    - - [04/Aug/2001:20:11:40 +0100] "POST / HTTP/1.1" 200 139
      10.160.16.45 - - [04/Aug/2001:20:11:39 +0100] "GET /printers/DANKA_P450 HTTP/1.0" 200 7319
      10.160.16.45 - - [04/Aug/2001:20:11:40 +0100] "GET /images/title-logo.gif HTTP/1.0" 200 5729

  You see a seperate line for each single access, showing the IP address of the accessing client, date and time of access, method of access (`POST` or `GET`), the requested ressource, the &HTTP; version used by the client, status code and the number of transferred bytes. Status code 200 means successful-OK the 401 in the above example was an unauthorised access which was denied. For a detailed explanation of the log format go to the &CUPS; Software Adminstrator Manual.

Error log file

  If this does not start with a leading `/`, then it is assumed to be relative to the server root. The default setting is `/var/log/cups/error_log`.

  You can also use the special name `syslog` to send the output to the syslog file or daemon.

  Enter the path, for example ``/var/log/cups/error_log``.

  The error log excerpt below shows you the part logged for printing the test page with the default setting of Log level to info. For an explanation of the Log Level setting see further below.

      kurt@transmeta:~
      > tail  /var/log/cups/error_log

      I [04/Aug/2001:23:15:10 +0100] Job 213 queued on 'DANKA_P450' by 'root'
      I [04/Aug/2001:23:15:10 +0100] Started filter /usr/lib/cups/filter/pstops (PID 18891) for job 213.
      I [04/Aug/2001:23:15:10 +0100] Started backend /usr/lib/cups/backend/lpd (PID 18892) for job 213.

Page log file

  If this does not start with a leading `/` then it is assumed to be relative to the server root. The default is `/var/log/cups/page_log`

  You can also use the special name `syslog` to send the output to the syslog file or daemon.

  Enter the path, for example ``/var/log/cups/page_log``.

  The page log file has a line for every single page of every job printed.

  Here is what some entries look like:

      kurt@transmeta:~
      > tail  /var/log/cups/page_log

      GIMP_print_stp_HP kdetest 201 [03/Aug/2001:03:18:03 +0100] 4 1
      GIMP_print_stp_HP kdetest 201 [03/Aug/2001:03:18:03 +0100] 5 1
      GIMP_print_stp_HP kdetest 202 [03/Aug/2001:11:46:49 +0100] 1 1
      GIMP_print_stp_HP kdetest 203 [03/Aug/2001:11:46:54 +0100] 1 1
      DANKA_infotec_P450 kurt 204 [04/Aug/2001:03:29:00 +0100] 1 33
      DANKA_infotec_P450 kurt 204 [04/Aug/2001:03:29:00 +0100] 2 33
      DANKA_infotec_P450 kurt 204 [04/Aug/2001:03:29:00 +0100] 3 33
      DANKA_infotec_P450 kurt 204 [04/Aug/2001:03:29:00 +0100] 4 33
      DANKA_infotec_P450 root 205 [04/Aug/2001:19:12:34 +0100] 1 14
      DANKA_infotec_P450 root 206 [04/Aug/2001:19:15:20 +0100] 1 1

  In this excerpt of the file you find information on the name of the printers (GIMP_print_stp_HP and DANKA_infotec_P450) used through this server, the user names (kdetest, kurt and root), the job-IDs (201 to 205), time of printing, page number inside the job and the number of copies for the pages. For example, job-ID 204 had 4 pages and 33 copies printed, job-ID 205 had 14 copies of just 1 page) .

  &CUPS; is dependent (for its calculation of the number of pages in a job) on passing the &PostScript; through the pstops filter. See the &kivio; Flowchart on the &CUPS; filter architecture for an idea about were this filter fits into the whole printing process). More, `pstops` depends for the counting on a DSC conforming (DSC is Document Structuring Conventions, a standard defined by Adobe) to be sent by the client. In most cases this is working.

  However, this page accounting does not work for any raw printer queues (as those, by definition, don't use any filtering on the &CUPS; host and are by-passing `pstops`.) Every job going through a raw queue is counted as a 1-page-job (with possibly multipe copies). This is especially true for all Jobs send from &Microsoft; &Windows; clients via Samba to the &CUPS; server, as those jobs are already arriving in the correct format for the printer, because the clients use the original printer driver.

  I am still looking for someone who will write a nice &CUPS; page log analysing tool. It should generate a report with a graphical output similar to the Webalizer's access log reports. This way you could have nice statistics to be used for accounting about usage of printers, load dependent on daytime or weekday, users &etc; Anyone?

Log level

  This setting controls the number of messages logged to the error log file. It can be one of the following:

  debug2

    Log everything.

  debug

    Log almost everything.

  info

    Log all requests and state changes.

  warn

    Log errors and warnings.

  error

    Log only errors.

  none

    Log nothing.

  If you need to troubleshoot (or if you want to study the inner workings of &CUPS;), set the log level to debug or debug2. Then the error_log will have a lot more entries (not just errors, but also informational entries).

  You can use this to watch live what &CUPS; is doing when you send a print job. In a &konsole; type:

      kurt@transmeta:~
      >tail -f -n100 /var/log/cups/error_log

  This will give you the last 100 lines (`-n` `100`) of the file onto the screen and a realtime update (`-f`)of what is happening. The following listing shows the printing of a test page (some pieces have been cut off for space reasons... Try it yourself if you need more info):

      I [04/Aug/2001:23:15:12 +0100] Job 214 queued on 'DANKA_P450' by 'root'
      D [04/Aug/2001:23:15:12 +0100] StartJob(214, 08426fe0)
      D [04/Aug/2001:23:15:12 +0100] StartJob() id = 214, file = 0/1
      D [04/Aug/2001:23:15:12 +0100] job-sheets=none,none
      D [04/Aug/2001:23:15:12 +0100] banner_page = 0
      D [04/Aug/2001:23:15:12 +0100] StartJob: argv = "DANKA_P450","214","root","KDE Print Test",
      [....]
      D [04/Aug/2001:23:15:12 +0100] StartJob: envp = "PATH=/usr/lib/cups/filter:/bin:/usr/bin", [....]
      D [04/Aug/2001:23:15:12 +0100] StartJob: statusfds = 5, 6
      D [04/Aug/2001:23:15:12 +0100] StartJob: filterfds[1] = 7, -1
      D [04/Aug/2001:23:15:12 +0100] StartJob: filter = "/usr/lib/cups/filter/pstops"
      D [04/Aug/2001:23:15:12 +0100] StartJob: filterfds[0] = 8, 9
      D [04/Aug/2001:23:15:12 +0100] start_process("/usr/lib/cups/filter/pstops", [....]
      I [04/Aug/2001:23:15:12 +0100] Started filter /usr/lib/cups/filter/pstops (PID 18991) for job 214.
      D [04/Aug/2001:23:15:12 +0100] StartJob: backend = "/usr/lib/cups/backend/lpd"
      D [04/Aug/2001:23:15:12 +0100] StartJob: filterfds[1] = -1, 7
      D [04/Aug/2001:23:15:12 +0100] start_process("/usr/lib/cups/backend/lpd", [....]
      I [04/Aug/2001:23:15:12 +0100] Started backend /usr/lib/cups/backend/lpd (PID 18992) for job 214.
      D [04/Aug/2001:23:15:12 +0100] Page = 595x842; 15,16 to 580,833 [....]

  The lines tagged D at the beginning are debug level entries, the ones tagged I are there in info level.

Max log file size

  Controls the maximum size of each log file before they are rotated. Defaults to 1048576 (1 Mb). Set this to 0 to disable log rotation.

  Enter an size in bytes, for example `1048576`

## Server Directories Configuration

The dialogue to configure the &CUPS; server. Different directories are to be set here. Normally you don't need to change anything in this section. In case you play around with fancy (TrueType, &PostScript; or other) fonts on your system, this qis the place to do the settings for using those fonts when printing. Server directory settings include:

- Executables: where to find the server executables

- Configuration: where to find the server configuration files

- Data: where to find the server data files

- Temporary files: where to put the server temporary print files

- Temporary Requests: where to find the server

- Font Path: where to find the server fonts

&CUPS; server configuration dialogue: &HTTP; configuration
The dialogue to configure the &CUPS; server: &HTTP; configuration

Executables

  The root directory for the scheduler executables. By default this is `/usr/lib/cups` (or `/usr/lib32/cups` on IRIX 6.5)

Configuration

  The root directory for the scheduler. By default, `/etc/cups`.

  On the authors SuSE system, this is `/usr/share/doc/cups`. It contains all the HTML or PDF documentation for &CUPS; which is available through the Web interface at http://localhost:631/documentation.html

Data

  The root directory for the &CUPS; data files. By default this is `/usr/share/cups`

  It contains such things as banners, charsets, data, drivers, fonts, and `pstoraster` templates.

Temporary files

  The directory to put temporary files in. This directory must be writable by the user defined on the previous screen. This defaults to either `/var/spool/cups/tmp` or the value of the `TMPDIR` environment variable.

Temporary Requests

  The directory where request files are stored. By default this is `/var/spool/cups`

Font path

  The place to configure the &CUPS; server for handling your fancy fonts (TrueType or &PostScript;). &CUPS; will look here for fonts to embed in printfiles. This currently only affects the `pstoraster` filter, and the default is `/usr/share/cups/fonts`.

  To specifiy more than one directory, list them with double colons as separator. Do it like this:

  `/path/to/first/fontdir/:/path/to/second/fontdir/:/path/to/last/fontdir/`

  For the Font path directive to work as intended, the application that wants to print needs to:

  - Either correctly reference its desired fonts in the header of the generated &PostScript;

  - Or embed the font into the &PostScript; file.

  Referencing the font by name leaves it up to the RIP and print device to respect and actually use it. RIP or printer can only use the desired font, if it is available on the system.

  In the case of a &PostScript; printer, this needs to be a printer-resident font. If the printer doesn't have this font, it will try and replace it by an adequately similar font.

  In the case of a non &PostScript; printer, this is done by &CUPS; and its RIP-ing filtering system. &CUPS; will use the font path directive to grab the correct font when RIP-ing the &PostScript; in the `pstoraster` filter.

  In the case of a &PostScript; output device, &CUPS; is just spooling the file (actually, it is passing it through the `pstops` filter for accounting or n-up purposes), not working on it. Therefore, if you print to a &PostScript; printer it is solely the printer's responsibility to use the font asked for. It can't, if the font is neither loaded into the printer nor embedded in the &PostScript;.

## Server HTTP Configuration

The dialogue to configure the &CUPS; server &HTTP; settings is shown here.

&CUPS; server &HTTP; settings are the following ones:

- the Document directory

- the Default Language

- the Default Charset

Dialogue to configure the &CUPS; server &HTTP; settings
Dialogue to configure the &CUPS; server &HTTP; settings

Document directory

  The root directory for &HTTP; documents that are served. By default the compiled in directory, `/usr/share/cups/doc`

Default Language

  The default language, if not specified by the browser. If not specified, the current locale is used.

  Use the two letter locale codes, for example `en` or `de`.

Default charset

  The default character set to use. If not specified, this defaults to UTF-8. This can also be overridden directly in the HTML documents.

## Server encryption support configuration

This is the dialogue to configure the &CUPS; server security settings. The server encyption support settings are these:

- Server certificate: the file to read containing the server's certificate

- Server key: the file to read containing the server's key

&CUPS; server configuration dialogue: security overview
The dialogue to configure the &CUPS; server: security settings

Server certificate

  The file to read containing the server's certificate. Defaults to `/etc/cups/ssl/server.crt`.

Server key

  The file to read containing the server's key. Defaults to `/etc/cups/ssl/server.key`

## Server Miscellaneous Configuration

The dialogue to configure the &CUPS; server miscellaneous settings is shown here. The following server settings are done through this screen:

- Preserve job history: whether to preserve a job history for later re-view

- Preserve job files: whether to preserve fully RIP-ed job files for later re-print

- Printcap file: setting the name of and the path to a printcap file

- RIP Cache: setting the size of the RIP cache in memory

- Filter Limit: defining a filter limit

Dialogue to configure the &CUPS; server miscellaneous settings
Dialogue to configure the &CUPS; server miscellaneous settings

Preserve job history (after completion)

  Whether or not to preserve the job history after a job is completed, cancelled, or stopped. The default is yes

Preserve job file (after completion)

  Whether or not to preserve the job files after a job is completed, cancelled, or stopped. The default is no.

Printcap file

  The name of the printcap file. The default is no filename. Leave this blank, to disable printcap file generation.

  The printcap setting is only needed to satisfy older applications in need of such a file.

RIP cache

  The amount of memory that each RIP should use to cache bitmaps. The value can be any real number, followed by k for kilobytes, m for megabytes, gfor gigabytes, or t for tiles, where one tile is 256 x 256 pixels. The default value is 8m.

Filter limit

  Sets the maximum cost of all job filters that can be run at the same time. A limit of 0 means no limit. A typical job may need a filter limit of at least 200. Limits less than the minimum required by a job force a single job to be printed at any time. The default limit is 0 (unlimited).

## Network General Configuration

The dialogue to configure the &CUPS; server network settings is shown here. It includes:

- Look for hostname on IP addresses

- Port

- Max request size

- Timeout

Dialogue to configure the &CUPS; server network settings
Dialogue to configure the &CUPS; server network settings

Look for hostname on IP addresses

  Whether or not to do lookups on IP addresses to get a fully-qualified hostname. This defaults to off, for performance reasons.

Port

  Enter here Ports and addresses that the server will listen to. The default port 631 is reserved for the Internet Printing Protocol, and is what we use here.

  You can have multiple entries, to listen to more than one port or address, or to restrict access.

  Unfortunately, most web browsers don't support TLS or &HTTP; upgrades for encryption. If you want to support web-based encryption, you'll probably need to listen on port 443, the HTTPS port.

  Use the Add and Remove buttons to add and remove entries from the list.

  You can enter ports on their own, &eg; `631`, or hostnames with ports, &eg; `myhost:80` or `1.2.3.4:631`.

Max request size

  Controls the maximum size of &HTTP; requests and print files. The default setting is 0, which disables this feature.

Timeout

  The timeout (in seconds) before requests time out. The default is 300 seconds.

## Network Clients Configuration

The dialogue to configure the &CUPS; network client settings is shown here. It includes:

- Accept "Keep Alive" requests

- KeepAliveTimeout:

- MaxClients:

dialogue to configure the &CUPS; network client settings
Dialogue to configure the &CUPS; network client settings

Accept "Keep Alive" requests

  Whether or not to support the Keep-Alive connection option. The default is on.

Keep alive timeout

  The timeout (in seconds) before Keep-Alive connections are automatically closed. The default is 60 seconds.

Max number of clients

  Controls the maximum number of simultaneous clients that will be handled. Defaults to 100.

## Browsing General Configuration

The dialogue to configure the &CUPS; browsing general settings is shown here. It includes:

- Enable browsing

- Use short names when possible

- Use implicit classes

Dialogue to configure the &CUPS; browsing general settings
Dialogue to configure the &CUPS; browsing general settings

Enable browsing

  Whether or not to broadcast printer information to other &CUPS; servers. Enabled by default.

Use short names when possible

  Whether or not to use short names for remote printers when possible (&eg; printer instead of printer@host). Enabled by default.

Use implicit classes

  Whether or not to use implicit classes.

  Printer classes can be specified explicitly, in the `classes.conf` file, implicitly based upon the printers available on the LAN, or both.

  When Implicit classes are enabled, printers on the LAN with the same name (&eg; Acme-LaserPrint-1000) will be put into a class with the same name. This allows you to setup multiple redundant queues on a LAN without a lot of administrative difficulties. If a user sends a job to Acme-LaserPrint-1000, the job will go to the first available queue.

  This option is enabled by default.

## Browsing Connection Configuration

The dialog to configure the &CUPS; server browsing connection is shown here. Browsing connection settings include:

- Broadcast addresses: The (UDP) broadcast address to transmit printer information to

- Broadcast Port: The port number to use for broadcasting

- Poll addresses: The address(es) to poll for information about printers on servers that might not broadcast (or whose broadcasts might not reach your LAN due to routers in between).

Dialogue to configure the &CUPS; server browsing connection
Dialogue to configure the &CUPS; server browsing connection

Broadcast addresses

  After pressing the Add button, you will see the following dialogue to enter a new value for outgoing broadcasting browse packets. It is the same kind of dialogue as for adding other &CUPS; server addresses to be polled for printer information.

  Dialogue to enter a new value for broadcasting browse packets to
  Dialogue to enter a new value for broadcasting browse packets to

  This option specifies a broadcast address to be used. By default, browsing information is broadcast to all active interfaces.

  &HP-UX; 10.20 and earlier do not properly handle broadcast unless you have a Class A, B, C or D netmask (&ie;, there is no CIDR support).

Broadcast port

  The port used for UDP broadcasts. By default this is the IPP port; if you change this, you need to do it on all servers. Only one BrowsePort is recognised.

Poll addresses

  Poll the named server(s) for printers.

## Browsing Masks Configuration

The dialogue to configure the &CUPS; server allowed and/or denied browse packets from other servers is shown here.

- Browse allow:

- Browse deny:

- Browse order:

Dialogue to configure the &CUPS; server allowed and/or denied browse packets from other servers
Dialogue to configure the &CUPS; server allowed and/or denied browse packets from other servers

Add Browse Address dialogue

  The dialogue to enter a new value for the address of another &CUPS; server to accept browse packets from is shown here. It is opened by clicking on the Add... button beside the field named Browse Allow:. It is the same dialogue as for adding denied broadcast sending addresses.

  The dialogue to enter a new value for the address of another &CUPS; server to accept browse packets from is shown here.

  Dialogue to enter a new value for the address of another &CUPS; server to accept browse packets from
  Dialogue to enter a new value for the address of another &CUPS; server to accept browse packets from
Browse allow and Browse deny

  Browse allow specifies an address mask to allow for incoming browser packets. The default is to allow packets from all addresses.

  Browse deny specifies an address mask to deny for incoming browser packets. The default is to deny packets from no addresses.

  Both Browse allow and Browse deny accept the following notations for addresses:

  - `All`

  - `None`

  - `*.domain.com`

  - `.domain.com`

  - `host.domain.com`

  - `nnn.*`

  - `nnn.nnn.*`

  - `nnn.nnn.nnn.*`

  - `nnn.nnn.nnn.nnn`

  - `nnn.nnn.nnn.nnn/mmm`

  - `nnn.nnn.nnn.nnn/mmm.mmm.mmm.mmm`

  The hostname/domain name restrictions will only work if you have turned hostname lookups on!

Browse order

  Specifies the order of the allow/deny comparisons.

## Browsing Timeouts Configuration

The dialogue to configure the &CUPS; server browse timeout settings is shown here. Browse timeout settings include:

- Browse Interval

- Browse Timeout

Dialogue to configure the &CUPS; server browse timeout settings
dialogue to configure the &CUPS; server browse timeout settings

Browse interval

  The time between browsing updates in seconds. The default is 30 seconds.

  Note that browsing information is sent whenever a printer's state changes as well, so this represents the maximum time between updates.

  Set this to 0 to disable outgoing broadcasts so your local printers are not advertised, but you can still see printers on other hosts.

Browse timeouts

  The timeout (in seconds) for network printers - if we don't get an update within this time, the printer will be removed from the printer list.

  This number definitely should not be less than the browse interval period, for obvious reasons. Defaults to 300 seconds.

## Browsing Relay Configuration

The dialogue to configure the &CUPS; server as a browsing relay is shown here. Browsing relay settings include:

- Browser packets relay

Dialogue to configure the &CUPS; server as a browsing relay
Dialogue to configure the &CUPS; server as a browsing relay

Add Browse Relay dialogue

  The dialogue to enter a new value for an address pair to define browsing relaying between a &CUPS; server and a network is shown here.

  The dialogue to enter a new value for an address pair to define browsing relaying between a &CUPS; server and a network
  The dialogue to enter a new value for an address pair to define browsing relaying between a &CUPS; server and a network
Browser packets relay

  Relay browser packets from one address or network to another.

## Security Configuration

The dialogue to configure the &CUPS; server security settings for any of the defined server locations is shown here. It contains the following settings, which may be defined seperately for any valid resource (or location) of the &CUPS; server:

- System Group:

- Access Permissions:

- Auth Type:

- Auth Class:

- Auth Group Name:

- Encryption:

- Allow:

- Deny:

- Order:

Valid resources (or locations) of the &CUPS; server are:

- Server Root Location: /

- Server Administration Location: /admin

- All printers on the server: /printers

- Any individual printer on the server: &eg; /printers/infotec_P320

- All printer classess on the server: /classes:

- Any individual printer class on the server: &eg; /classes/all_infotecs_P320_or_P450

Dialogue to configure the &CUPS; server security settings for any of the defined server locations
dialogue to configure the &CUPS; server security settings for any of the defined server locations

For all locations that are not defined seperately the setting of the location above it is valid.

For example, you have a printer named infotec_P450 with no set security options. Then the security of the location /printers will take the reponsibility for this printer as it is a sub-location of/printers. If, in turn there is no security set for /printers, then the security for / (the general security) of the server takes responsibility. Either you have set this for your purpose or the compiiled-in default value takes over.

SystemGroup

  The group name for System or printer administration access. The default varies depending on the operating system, but will be sys, system or root (checked for in that order).

Access Permissions

  Access permissions for each directory served by the scheduler. Locations are relative to the document root.

Authorisation Type

  The authorisation to use:

  None

    Perform no authentication.

  Basic

    Perform authentication using the &HTTP; Basic method.

  Digest

    Perform authentication using the &HTTP; Digest method.

  Local certificate authentication can be substituted by the client for Basic or Digest, when connecting to the localhost interface.

Authorisation Class

  The authorisation class. Currently only Anonymous, User, System (valid user belonging to the group set as system group), and group (valid user belonging to the specified group) are supported.

Authorisation Group Name

  The group name for Group authorisation

Encryption

  Whether or not to use encryption. This depends on having the OpenSSL linked into the &CUPS; library and scheduler.

  Possible values are:

  Always

    Always use encryption (SSL)

  Never

    Never use encryption.

  Required

    Use TLS encryption upgrade.

  IfRequested

    Use encryption if the server requests it.

Allow

  Allows access from the specified hostname, domain, IP address or network. Possible values are:

  - `All`

  - `None`

  - `*.domain.com`

  - `.domain.com`

  - `host.domain.com`

  - `nnn.*`

  - `nnn.nnn.*`

  - `nnn.nnn.nnn.*`

  - `nnn.nnn.nnn.nnn`

  - `nnn.nnn.nnn.nnn/mmm`

  - `nnn.nnn.nnn.nnn/mmm.mmm.mmm.mmm`

  The host and domain address require that you enable hostname lookups, as described earlier.

Deny

  Denies access from the specified hostname, domain, IP address or network. Possible values are:

  - `All`

  - `None`

  - `*.domain.com`

  - `.domain.com`

  - `host.domain.com`

  - `nnn.*`

  - `nnn.nnn.*`

  - `nnn.nnn.nnn.*`

  - `nnn.nnn.nnn.nnn`

  - `nnn.nnn.nnn.nnn/mmm`

  - `nnn.nnn.nnn.nnn/mmm.mmm.mmm.mmm`

  The host and domain address require that you enable hostname lookups, as described earlier.

Order

  The order of the allow and deny processing.

## Example: How To Define The Security For All Printers

The dialogue to configure the &CUPS; server security settings is discussed here. We use the example to add security definitions other than the default ones for the resource named all printers. For the &CUPS; web server, this is the location you access through http://localhost:631/printers/ or (remotely) through http://cups.server.name:631/printers/

The first screenshot shows the general location for this setting. Select Add or Modify a resource for which you want to decide about its security settings.

Dialogue to configure the &CUPS; server security settings
Dialogue to configure the &CUPS; server security settings

This dialogue is to add a new resource. It looks similar if you want to modify an already existing resource. Here are the general options:

Dialogue to add a new resource.
Dialogue to add a new resource.

.This is the second part or the dialogue is to add a new ressource. It looks similar if you want to modify an already existing resource. Here you define the actual access masks for the resource in question.

Dialogue to add a new resource.
Dialogue to add a new resource.
Resource dialogue
Resource dialogue
Resource dialogue
Resource dialogue
Resource dialogue
Resource dialogue
Resource dialogue
Resource dialogue